<template>
	<mind-view>
		<template v-slot:toolbar-actions>
			<el-button type="primary" size="small" @click="$refs.formulario?.onSubmit()" :disabled="!modificado" >Aplicar Cambios</el-button>
		</template>
		<mind-form  
			v-model="recurso"  v-model:modified="modificado"
			@submit="onSubmit" v-loading="isLoading"
			ref="formulario" 
			>
			<template v-slot="{form}">
					<el-row  >
						<el-col :lg="12">
							<el-form-item label="Nombre">
								<el-input v-model="form.nombre" />
							</el-form-item>
						</el-col>
					</el-row>
					<el-row  >
						<el-col :lg="12">
							<el-form-item label="Comision">
								<el-slider
									v-model="form.comision"
									:step="10" show-input
									show-stops :marks="{0: '0%', 50: '50%', 100: '100%'}">
								</el-slider>
							</el-form-item>
						</el-col>
					</el-row>
					<el-divider content-position="left">Gastos a Cargo de la Agencia</el-divider>
					<el-row  >
						<el-col :lg="12">
							<el-form-item label="Combustible">
								<el-slider
									v-model="form.combustibleAgencia"
									:step="10" show-input :marks="{0: '0%', 50: '50%', 100: '100%'}"
									show-stops>
								</el-slider>
							</el-form-item>
						</el-col>
						<el-col :lg="12">
							<el-form-item label="Gastos">
								<el-slider
									v-model="form.gastosAgencia"
									:step="10" show-input :marks="{0: '0%', 50: '50%', 100: '100%'}"
									show-stops>
								</el-slider>
							</el-form-item>
						</el-col>
					</el-row>
			</template>
		</mind-form>
	</mind-view>
</template>
<script>
import comisiones from '@/model/comisiones'

export default {
	async created(){
		this.isLoading = true;
		let id = this.$route.params.id;
		if (id == "new") {
			this.recurso = comisiones.new()
		} else {
			this.recurso = await comisiones.get(id)

		}
		this.isLoading = false;
	},
	computed: {
		esNuevo() {
			return this.recurso?._isNew
		}
		
	},

	methods: {
		async onSubmit(v) {
			delete(v.ultimaActualizacion)
			delete(v.estado)
			this.recurso = v
			const key = comisiones.getKey()
			const esNuevo = this.esNuevo
			if(esNuevo) {
				this.recurso = await comisiones.post(this.recurso)
				.then((response)=>{
					const id = response[0][key]
					this.$message({
						type: 'success',
						message: `Comisión creada correctamente`,
					})
					//modifico la ruta
					const path = this.$router.currentRoute.path.replace(/\/new$/, `/${id}`)
					this.$router.replace(path)
				})
			} else {
				this.recurso = await comisiones.patch(this.recurso)
				this.$message({
					type: 'success',
					message: "Comisión actualizada correctamente",
				})
			}

		},
	},
	data() {
		return {
			recurso: {},
			modificado: false, 

		}
	}
}
</script>